Index: styles/default/lines
===================================================================
--- styles/default/lines	(revision 1871)
+++ styles/default/lines	(working copy)
@@ -80,7 +80,7 @@
 junction=roundabout & highway=secondary [0x0c road_class=2 road_speed=2 resolution 20]
 junction=roundabout & highway=tertiary [0x0c road_class=1 road_speed=1 resolution 21]
 junction=roundabout & highway=unclassified [0x0c road_class=1 road_speed=1 resolution 21]
-junction=roundabout [0x0c road_class=0 road_speed=1 resolution 21]
+junction=roundabout [0x0c road_class=0 road_speed=1 resolution 22]
 
 # Ways that may or may not be useable
 
@@ -90,14 +90,14 @@
 highway=* & disused=yes [0x07 road_class=0 road_speed=1 resolution 22]
 
 # Ways sorted roughly by descending order of class
-highway=motorway {add oneway = yes; add bicycle = no; add foot = no } [0x01 road_class=4 road_speed=7 resolution 14]
-highway=motorway_link {add oneway = yes; add bicycle = no; add foot = no } [0x09 road_class=3 road_speed=2 resolution 16]
+highway=motorway {add oneway = yes; add bicycle = no; add foot = no } [0x01 road_class=4 road_speed=7 resolution 16]
+highway=motorway_link {add oneway = yes; add bicycle = no; add foot = no } [0x09 road_class=3 road_speed=2 resolution 18]
 highway=* & motorroad=yes {add bicycle = no; add foot = no}
-highway=trunk [0x02 road_class=4 road_speed=5 resolution 16]
-highway=trunk_link [0x09 road_class=3 road_speed=2 resolution 18]
-highway=* & motorroad=yes [0x02 road_class=4 road_speed=4 resolution 16]
+highway=trunk [0x02 road_class=4 road_speed=5 resolution 18]
+highway=trunk_link [0x09 road_class=3 road_speed=2 resolution 19]
+highway=* & motorroad=yes [0x02 road_class=4 road_speed=4 resolution 18]
 highway=primary [0x03 road_class=3 road_speed=4 resolution 19]
-highway=primary_link [0x08 road_class=3 road_speed=1 resolution 19]
+highway=primary_link [0x08 road_class=3 road_speed=1 resolution 20]
 highway=secondary [0x04 road_class=2 road_speed=3 resolution 20]
 highway=secondary_link [0x08 road_class=2 road_speed=1 resolution 20]
 highway=tertiary [0x05 road_class=1 road_speed=3 resolution 20]
@@ -116,26 +116,26 @@
 highway=cycleway {add access = no; add bicycle = yes; add foot = yes} [0x07 road_class=0 road_speed=1 resolution 23]
 
 highway=footway|highway=path|highway=steps {add access = no; add foot = yes} [0x16 road_class=0 road_speed=0 resolution 23]
-highway=track [0x0a road_class=0 road_speed=1 resolution 21]
-highway=unsurfaced [0x0a road_class=0 road_speed=1 resolution 21]
-highway=road { add mkgmap:dead-end-check = false} [0x06 road_class=0 road_speed=1 resolution 21]
+highway=track [0x0a road_class=0 road_speed=1 resolution 22]
+highway=unsurfaced [0x0a road_class=0 road_speed=1 resolution 22]
+highway=road { add mkgmap:dead-end-check = false} [0x06 road_class=0 road_speed=1 resolution 22]
 
 # Mop up any unrecognised highway types
 highway=* & area!=yes [0x07 ]
 
 natural=coastline [0x15 resolution 12]
-power=line [0x29 resolution 20]
+power=line [0x29 resolution 21]
 
-railway=abandoned [0x0a road_class=0 road_speed=1 resolution 21]
-railway=light_rail & !(tunnel=yes) [0x14 resolution 17]
-railway=narrow_gauge & !(tunnel=yes) [0x14 resolution 17]
-railway=preserved & !(tunnel=yes) [0x14 resolution 17]
-railway=rail & !(tunnel=yes) [0x14 resolution 17]
-railway=subway & !(tunnel=yes) [0x14 resolution 17]
-railway=tram & !(tunnel=yes) [0x14 resolution 18]
+railway=abandoned [0x0a road_class=0 road_speed=1 resolution 22]
+railway=light_rail & !(tunnel=yes) [0x14 resolution 22]
+railway=narrow_gauge & !(tunnel=yes) [0x14 resolution 22]
+railway=preserved & !(tunnel=yes) [0x14 resolution 22]
+railway=rail & !(tunnel=yes) [0x14 resolution 20]
+railway=subway & !(tunnel=yes) [0x14 resolution 21]
+railway=tram & !(tunnel=yes) [0x14 resolution 22]
 railway=platform {add access = no; add foot = yes} [0x16 road_class=0 road_speed=0 resolution 23]
 
-route=ferry {add mkgmap:ferry=1} [0x1b road_class=3 road_speed=0 resolution 18]
+route=ferry {add mkgmap:ferry=1} [0x1b road_class=3 road_speed=0 resolution 19]
 
 waterway=canal [0x1f resolution 21]
 waterway=drain [0x1f resolution 22]
@@ -150,9 +150,9 @@
 # are frequently tagged with both and we want the highway to take priority.
 boundary=administrative { name '${mkgmap:boundary_name}' }
 boundary=administrative & admin_level<3 [0x1e resolution 16]
-boundary=administrative & admin_level<5 [0x1d resolution 18]
-boundary=administrative & admin_level<7 [0x1c resolution 20]
-boundary=administrative & admin_level<9 [0x1c resolution 21]
+boundary=administrative & admin_level<5 [0x1d resolution 19]
+boundary=administrative & admin_level<7 [0x1c resolution 21]
+boundary=administrative & admin_level<9 [0x1c resolution 22]
 boundary=administrative [0x1c resolution 22]
 boundary=national [0x1e resolution 17]
-boundary=political [0x1c resolution 17]
+boundary=political [0x1c resolution 19]
Index: styles/default/options
===================================================================
--- styles/default/options	(revision 1871)
+++ styles/default/options	(working copy)
@@ -17,7 +17,7 @@
 
 # The levels specification for this style
 # 
-levels = 0:24, 1:22, 2:20, 3:18, 4:16
+levels = 0:24, 1:22, 2:21, 3:20, 4:19, 5:18, 6:16
 
 extra-used-tags= name hello world
 
Index: styles/default/polygons
===================================================================
--- styles/default/polygons	(revision 1871)
+++ styles/default/polygons	(working copy)
@@ -8,42 +8,42 @@
 # and http://wiki.openstreetmap.org/wiki/Mkgmap/help/Custom_styles
 # for more information.
 
-aeroway=airport [0x07 resolution 18]
-aeroway=aerodrome [0x07 resolution 18]
-aeroway=helipad [0x0e resolution 20]
+aeroway=airport [0x07 resolution 20]
+aeroway=aerodrome [0x07 resolution 20]
+aeroway=helipad [0x0e resolution 22]
 
-amenity=kindergarten [0x0a resolution 18]
-amenity=cafe | amenity=fast_food | amenity=restaurant | amenity=food_court [0x08 resolution 20]
-amenity=college [0x0a resolution 18]
-amenity=grave_yard [0x1a resolution 18]
-amenity=hospital [0x0b resolution 18]
-amenity=nursing_home [0x0b resolution 21]
-parking=underground | parking=multi-storey [0x06 resolution 21]
-amenity=parking | parking=surface [0x05 resolution 21]
-amenity=prison [0x04 resolution 20]
-amenity=school [0x0a resolution 20]
+amenity=kindergarten [0x0a resolution 22]
+amenity=cafe | amenity=fast_food | amenity=restaurant | amenity=food_court [0x08 resolution 22]
+amenity=college [0x0a resolution 22]
+amenity=grave_yard [0x1a resolution 21]
+amenity=hospital [0x0b resolution 20]
+amenity=nursing_home [0x0b resolution 22]
+parking=underground | parking=multi-storey [0x06 resolution 22]
+amenity=parking | parking=surface [0x05 resolution 22]
+amenity=prison [0x04 resolution 22]
+amenity=school [0x0a resolution 22]
 # amenity=supermarket is superceded by shop=supermarket or landuse=retail
-amenity=supermarket [0x08 resolution 20]
-amenity=university [0x0a resolution 18]
+amenity=supermarket [0x08 resolution 22]
+amenity=university [0x0a resolution 21]
 
-healthcare=* [0x0b resolution 21]
+healthcare=* [0x0b resolution 23]
 
-landuse=allotments [0x4e resolution 20]
-landuse=basin [0x3f resolution 18]
-landuse=cemetary [0x1a resolution 18]
-landuse=cemetery [0x1a resolution 18]
-landuse=commercial [0x0c resolution 18]
-landuse=construction [0x0c resolution 20]
-landuse=farm [0x4e resolution 18]
-landuse=farmyard [0x4e resolution 18]
+landuse=allotments [0x4e resolution 21]
+landuse=basin [0x3f resolution 20]
+landuse=cemetary [0x1a resolution 21]
+landuse=cemetery [0x1a resolution 21]
+landuse=commercial [0x0c resolution 19]
+landuse=construction [0x0c resolution 21]
+landuse=farm [0x4e resolution 20]
+landuse=farmyard [0x4e resolution 20]
 landuse=forest [0x50 resolution 18]
-landuse=greenfield [0x17 resolution 18]
-landuse=industrial [0x0c resolution 18]
+landuse=greenfield [0x17 resolution 20]
+landuse=industrial [0x0c resolution 19]
 landuse=meadow [0x17 resolution 18]
-landuse=military [0x04 resolution 18]
-landuse=quarry [0x0c resolution 18]
-landuse=recreation_ground [0x19 resolution 18]
-landuse=reservoir [0x3f resolution 18]
+landuse=military [0x04 resolution 19]
+landuse=quarry [0x0c resolution 19]
+landuse=recreation_ground [0x19 resolution 19]
+landuse=reservoir [0x3f resolution 19]
 # on resolution 24, display building=* instead of landuse=residential
 landuse=residential [0x10 resolution 23-18]
 landuse=retail [0x08 resolution 20]
@@ -51,27 +51,27 @@
 landuse=vineyard [0x4e resolution 20]
 landuse=wood [0x50 resolution 18]
 
-leisure=common [0x17 resolution 20]
-leisure=garden [0x17 resolution 20]
-leisure=golf_course [0x18 resolution 20]
-leisure=ice_rink [0x19 resolution 21]
+leisure=common [0x17 resolution 21]
+leisure=garden [0x17 resolution 21]
+leisure=golf_course [0x18 resolution 21]
+leisure=ice_rink [0x19 resolution 22]
 leisure=marina [0x09 resolution 20]
-leisure=nature_reserve [0x16 resolution 18]
+leisure=nature_reserve [0x16 resolution 19]
 leisure=park [0x17 resolution 20]
-leisure=pitch { name '${name} (${sport})' | '${name}' } [0x19 resolution 20]
-leisure=playground [0x17 resolution 20]
-leisure=recreation_ground [0x19 resolution 18]
+leisure=pitch { name '${name} (${sport})' | '${name}' } [0x19 resolution 21]
+leisure=playground [0x17 resolution 22]
+leisure=recreation_ground [0x19 resolution 21]
 leisure=sports_center | leisure=sports_centre { name '${name} (${sport})' | '${name}' } [0x19 resolution 20]
-leisure=stadium { name '${name} (${sport})' | '${name}' } [0x19 resolution 19]
-leisure=track & area=yes { name '${name} (${sport})' | '${name}' } [0x19 resolution 18]
-leisure=water_park [0x09 resolution 18]
+leisure=stadium { name '${name} (${sport})' | '${name}' } [0x19 resolution 20]
+leisure=track & area=yes { name '${name} (${sport})' | '${name}' } [0x19 resolution 21]
+leisure=water_park [0x09 resolution 21]
 
-military=airfield [0x04 resolution 18]
-military=barracks [0x04 resolution 18]
-military=danger_area [0x04 resolution 18]
-military=range [0x04 resolution 18]
+military=airfield [0x04 resolution 21]
+military=barracks [0x04 resolution 23]
+military=danger_area [0x04 resolution 20]
+military=range [0x04 resolution 20]
 
-natural=glacier [0x4d resolution 16]
+natural=glacier [0x4d resolution 18]
 natural=marsh [0x51 resolution 20]
 natural=mud [0x51 resolution 20]
 natural=wetland [0x51 resolution 20]
@@ -81,20 +81,20 @@
 natural=sea [0x32 resolution 10]
 natural=wood [0x50 resolution 18]
 
-place=village [0x03 resolution 18]
-place=island & name=* [0x53 resolution 18]
+place=village [0x03 resolution 19]
+place=island & name=* [0x53 resolution 19]
 place=islet & name=* [0x53 resolution 20]
 
-shop=* [0x08 resolution 20]
+shop=* [0x08 resolution 22]
 
 # squares and plazas
-highway=pedestrian & area=yes [0x17 resolution 20]
+highway=pedestrian & area=yes [0x17 resolution 22]
 # other highways that have area=yes set must be parking lots
-highway=* & area=yes [0x05 resolution 21]
+highway=* & area=yes [0x05 resolution 22]
 
 waterway=riverbank [0x46 resolution 20]
 
-historic=museum | historic=memorial [0x1e resolution 20]
+historic=museum | historic=memorial [0x1e resolution 21]
 historic=archaeological_site | historic=ruins [0x1e resolution 21]
 
 # building tag should be last